public class Silmu {
  final static int TKOKO = 5,RAJA = 10;

  static void alusta(int[] luvut, int n, int kasvu)
  {
    int luku = 0, iraja = ( n > luvut.length ? luvut.length : n );

    for(int i = 0; i < iraja; i++) {
      luvut[i] = luku;
      luku += kasvu;
    }
  }

  static int montako_mahtuu(int[] luvut, int n, int raja)
  {
    int i = 0, summa = 0, iraja = ( n > luvut.length ? luvut.length : n );

    do {
      summa += luvut[i];
    } while ( summa < raja && ++i < iraja);
    return i;
  }

  static int summaa(int[] luvut, int n)
  {
    int i = 0,summa = 0;

    while (i < n) {
      summa += luvut[i];
      i++;
    }
    return summa;
  }

  static void tulosta(int[] luvut, int n)
  {
    for( int i = ( n > luvut.length ? luvut.length : n) - 1; i >= 0; i--)
      System.out.print(luvut[i]+" ");
    System.out.println();
  }

  public static void main(String[] args)
  {
    int luvut[] = new int[TKOKO];
    int n;

    alusta(luvut,TKOKO,3);
    n = montako_mahtuu(luvut,TKOKO,RAJA);

    System.out.println(n+" lukua mahtuuu alle "+RAJA+" niden summa on "
                       +summaa(luvut,n));
    System.out.print("Luvut ovat: ");
    tulosta(luvut,n);
  }
}
